<?php
// Done With Help of ChatGPT ^_^
$mydir = dirname(__FILE__);
$upload_path = "/remove_directional_chars_uploads/";
if ($_SERVER["REQUEST_METHOD"] == "POST" && isset($_FILES["file"])) {
    $uploadDir = $mydir.$upload_path;
    if (!is_dir($uploadDir)) {
        mkdir($uploadDir, 0777, true);
    } else {
        $getallfiles = glob($mydir.$upload_path."*");
        foreach ($getallfiles as $value) {
            unlink($value);
        }
    }

    $fileTmpPath = $_FILES["file"]["tmp_name"];
    $fileName = $_FILES["file"]["name"];
    
    // Remove directionality control characters
    $fileNameClean = preg_replace('/[\x{200E}\x{200F}\x{202A}-\x{202E}]/u', '', $fileName);
    $destination = $uploadDir . basename($fileNameClean);
    $fpath_to_download = $upload_path.$fileNameClean;
    
    if (move_uploaded_file($fileTmpPath, $destination)) {
        $msg =  "<div class='alert alert-success'>تم الرفع بنجاح: <a class='btn btn-primary' href='$fpath_to_download'>تنزيل الصورة</a></div>";
    } else {
        $msg =  "<div class='alert alert-success'>حدث خطأ أثناء محاولة رفع الملف.</div>";
    }
}
?>
<!DOCTYPE html>
<html lang="ar" dir="rtl">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>إزالة الـ Directionality Control Characters</title>
    <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.3.0/dist/css/bootstrap.min.css" rel="stylesheet">
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/6.4.0/css/all.min.css">
    <link rel="preconnect" href="https://fonts.googleapis.com">
    <link rel="preconnect" href="https://fonts.gstatic.com" crossorigin>
    <link href="https://fonts.googleapis.com/css2?family=Noto+Kufi+Arabic:wght@100..900&display=swap" rel="stylesheet">
    <style>
        body {
            background-color: #f8f9fa;
            font-family: "Noto Kufi Arabic", serif;
        }
        .upload-container {
            max-width: 400px;
            background: white;
            padding: 20px;
            border-radius: 10px;
            box-shadow: 0 0 10px rgba(0, 0, 0, 0.1);
        }
    </style>
</head>
<body class="d-flex justify-content-center align-items-center vh-100">
    <div class="upload-container text-center">
        <?php if (isset($msg)) {echo $msg;} ?>
        <h4 class="mb-3"><i class="fas fa-upload"></i> رفع الملف</h4>
        <form action="<?php echo $_SERVER['PHP_SELF']; ?>" method="post" enctype="multipart/form-data">
            <div class="mb-3">
                <input class="form-control" type="file" name="file" required>
            </div>
            <button type="submit" class="btn btn-primary w-100">
                <i class="fas fa-cloud-upload-alt"></i> رفع
            </button>
        </form>
    </div>
</body>
</html>
